/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package forme.modelitabele;

import domen.Mesto;
import domen.PoslovniPartner;
import java.util.List;
import javax.swing.table.AbstractTableModel;
import poslovnalogika.KontrolerPL;

/**
 *
 * @author student
 */
public class PartnerTableModel extends AbstractTableModel{

    List<PoslovniPartner> listaPartnera;

    public PartnerTableModel() {
        //listaPartnera = KontrolerPL.vratiInstancu().vratiSvePartnere();
        
    }

    public PartnerTableModel(List<PoslovniPartner> listaPartnera) {
        this.listaPartnera = listaPartnera;
    }

    
    Class [] tipoviKolona = {String.class,String.class,String.class,String.class,String.class,Mesto.class}; 
    
    String [] kolone = {"Maticni broj", "Naziv", "PIB", "Ulica", "Broj","Mesto"};
    
    @Override
    public String getColumnName(int column) {
        return kolone[column];
    }

    @Override
    public boolean isCellEditable(int rowIndex, int columnIndex) {
        return true;
    }

    @Override
    public Class<?> getColumnClass(int columnIndex) {
        return tipoviKolona[columnIndex];
    }
      
    
    
    
    
     
    
    
    @Override
    public int getRowCount() {
        return listaPartnera.size();
    }

    @Override
    public int getColumnCount() {
        //return 6;
        return kolone.length;
    }

    @Override
    public Object getValueAt(int rowIndex, int columnIndex) {
            
        System.out.println("get value at");
            PoslovniPartner partner = listaPartnera.get(rowIndex);
    
            switch (columnIndex){
                
                case 0: return partner.getMaticniBroj();
                
                case 1: return partner.getNaziv();
                
                case 2: return partner.getPib();
                
                case 3: return partner.getUlica();
                
                case 4: return partner.getBroj();
                
                case 5: return partner.getMesto();
                
                default: return "N/A";
            }
            
            
    }

    @Override
    public void setValueAt(Object aValue, int rowIndex, int columnIndex) {
        System.out.println("set value at");
        
        PoslovniPartner partner = listaPartnera.get(rowIndex);
        
        switch(columnIndex){
            
            case 0: partner.setMaticniBroj((String)aValue);
                    break;
            
            case 1: partner.setNaziv((String)aValue);
                    break;
            
            case 2: partner.setPib((String)aValue);
                    break;    
            
            case 3: partner.setUlica((String)aValue);
                    break;
            
            case 4: partner.setBroj((String)aValue);
                    break;
            
            case 5: partner.setMesto((Mesto)aValue);
                    break;
            
            
            
        }
    }
    
    
    
    
    public void dodajNovogPartnera(){
        
        listaPartnera.add(new PoslovniPartner());
        System.out.println("partneri:"+listaPartnera);
        fireTableDataChanged();
        //fireTableRowsInserted(listaPartnera.size()-1, listaPartnera.size()-1);
        
    }
    
    
    public PoslovniPartner obrisiPartnera(int selektovaniRed){
        
        if (selektovaniRed<listaPartnera.size()){
            PoslovniPartner partner = listaPartnera.remove(selektovaniRed);            
            fireTableRowsDeleted(selektovaniRed, selektovaniRed);
            return partner;            
        } else {
            return null;
        }
        
    }
    
    public List<PoslovniPartner> vratiPartnere(){
        return listaPartnera;
    }
}
