/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package poslovnalogika;

import dbbr.DBBroker;
import domen.Mesto;
import domen.PoslovniPartner;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;
import sun.security.pkcs11.Secmod;

/**
 *
 * @author student
 */
public class KontrolerPL {

    private List<Mesto> listaMesta;
    private List<PoslovniPartner> listaPartnera;

    DBBroker dbbr;

    private static KontrolerPL instanca;

    public static KontrolerPL vratiInstancu() {

        if (instanca == null) {
            instanca = new KontrolerPL();
        }

        return instanca;
    }

    private KontrolerPL() {

        listaMesta = new ArrayList();
        listaPartnera = new ArrayList();

        dbbr = new DBBroker();

        listaMesta.add(new Mesto(11000, "Beograd"));
        listaMesta.add(new Mesto(11070, "Novi Beograd"));
        listaMesta.add(new Mesto(11080, "Zemun"));
        listaMesta.add(new Mesto(35230, "Cuprija"));
        listaMesta.add(new Mesto(21000, "Novi Sad"));

    }

    public List<Mesto> vratiSvaMesta() throws SQLException {

        try {
        dbbr.otvoriKonekciju();
        List<Mesto> listaM = dbbr.vratiSvaMesta();
        dbbr.potvrdiTransakciju();
        return listaM;
        //return listaMesta;
        } catch (SQLException ex) {
            dbbr.ponistiTransakciju();
            throw ex;
        }finally{
            dbbr.zatvoriKonekciju();
        }

    }

    public void dodajMesto(Mesto mesto) {
        listaMesta.add(mesto);
    }

    public void sacuvajPartnera(PoslovniPartner partner) throws SQLException {
        //listaPartnera.add(partner);
        try {
            dbbr.otvoriKonekciju();
            dbbr.sacuvajPartnera(partner);
            dbbr.potvrdiTransakciju();
        } catch (SQLException ex) {
            dbbr.ponistiTransakciju();
            throw ex;
        }finally{
            dbbr.zatvoriKonekciju();
        }
    }
    
    public void sacuvajListuPartnera(List<PoslovniPartner> partneri) throws SQLException {
        //listaPartnera.add(partner);
        try {
            dbbr.otvoriKonekciju();
            
            for (int i = 0; i < partneri.size(); i++) {
                PoslovniPartner partner = partneri.get(i);
                dbbr.sacuvajPartnera(partner);
            }
            
            
            
            dbbr.potvrdiTransakciju();
        } catch (SQLException ex) {
            dbbr.ponistiTransakciju();
            throw ex;
        }finally{
            dbbr.zatvoriKonekciju();
        }
    }
    

    public List<PoslovniPartner> vratiSvePartnere() throws SQLException {
        //return listaPartnera;
         try {
        dbbr.otvoriKonekciju();
        List<PoslovniPartner> listaPartnera = dbbr.vratiSvePartnere();
        dbbr.potvrdiTransakciju();
        return listaPartnera;
        //return listaMesta;
        } catch (SQLException ex) {
            dbbr.ponistiTransakciju();
            throw ex;
        }finally{
            dbbr.zatvoriKonekciju();
        }
    }

}
